#include <linux/kernel.h>
#include <linux/module.h>
#include <asm/cpufeature.h>
#include <asm/processor.h>

static bool had_avx2;

static int __init mod_init(void)
{
	had_avx2 = boot_cpu_has(X86_FEATURE_AVX2);
	if (had_avx2)
		clear_cpu_cap(&boot_cpu_data, X86_FEATURE_AVX2);
	pr_info("AVX2 disabler loaded: %d -> %d\n", had_avx2, boot_cpu_has(X86_FEATURE_AVX2));
	return 0;
}

static void __exit mod_exit(void)
{
	bool pre_remove_had_avx2 = boot_cpu_has(X86_FEATURE_AVX2);
	if (had_avx2)
		set_cpu_cap(&boot_cpu_data, X86_FEATURE_AVX2);
	pr_info("AVX2 disabler unloaded: %d -> %d\n", pre_remove_had_avx2, boot_cpu_has(X86_FEATURE_AVX2));
}

module_init(mod_init);
module_exit(mod_exit);
MODULE_LICENSE("GPL v2");
MODULE_DESCRIPTION("AVX2 Disabler");
MODULE_AUTHOR("Jason A. Donenfeld <Jason@zx2c4.com>");
